#include <exec/exec.h>
#include <dos/dos.h>

#include <proto/exec.h>

extern LONG AmiSSLTest(void);

struct StackSwapStore {
	struct StackSwapStruct stackSwap;
	LONG returnValue;
	UBYTE stack[8192];
};

struct ExecBase *SysBase;

__saveds LONG Startup(void) {
	SysBase = *(struct ExecBase **) 4;

	struct Task *thisTask = FindTask(NULL);
	const ULONG currentStackSize = (UBYTE *) thisTask->tc_SPUpper - (UBYTE *) thisTask->tc_SPLower;
	if (currentStackSize < sizeof(((struct StackSwapStore *) 0)->stack)) {
		struct StackSwapStore *stackSwapStore = AllocVec(sizeof(struct StackSwapStore), MEMF_PUBLIC);
		if (NULL == stackSwapStore) {
			return RETURN_FAIL;
		}

		stackSwapStore->stackSwap.stk_Lower = stackSwapStore->stack;
		stackSwapStore->stackSwap.stk_Upper =
				(ULONG) stackSwapStore->stack + sizeof(((struct StackSwapStore *) 0)->stack);
		stackSwapStore->stackSwap.stk_Pointer = (void *) (stackSwapStore->stackSwap.stk_Upper - 16);
		StackSwap(&stackSwapStore->stackSwap);

		stackSwapStore->returnValue = AmiSSLTest();

		StackSwap(&stackSwapStore->stackSwap);
		const LONG returnValue = stackSwapStore->returnValue;
		FreeVec(stackSwapStore);
		return returnValue;
	}

	return AmiSSLTest();
}
